#include <flutter/dart_project.h>
#include <flutter/flutter_view_controller.h>
#include <windows.h>
#include <flutter/method_channel.h>
#include <flutter/plugin_registrar_windows.h>
#include "flutter_window.h"
#include "utils.h"
#include <protocol_handler/protocol_handler_plugin.h>
#include <flutter/standard_method_codec.h>
// 展示控制台
void ShowConsole() {
  HWND hWnd = ::GetConsoleWindow();
  if (hWnd != NULL) {
    ::ShowWindow(hWnd, SW_SHOW);
  }
}

// 隐藏控制台
void HideConsole() {
  HWND hWnd = ::GetConsoleWindow();
  if (hWnd != NULL) {
    ::ShowWindow(hWnd, SW_HIDE);
  }
}
// 一个例子：展示如何注册处理函数来响应Dart的调用。
void RegisterWithFlutter(flutter::PluginRegistrarWindows *registrar) {
  auto channel =
          std::make_unique<flutter::MethodChannel<flutter::EncodableValue>>(
                  registrar->messenger(), "com.naiyouwl.native_code",
                          &flutter::StandardMethodCodec::GetInstance());

  channel->SetMethodCallHandler(
          [](const flutter::MethodCall<flutter::EncodableValue>& call,
             std::unique_ptr<flutter::MethodResult<flutter::EncodableValue>> result) {
              if (call.method_name().compare("showConsole") == 0) {
                ShowConsole();
                result->Success(flutter::EncodableValue(true));
              } else if (call.method_name().compare("hideConsole") == 0) {
                HideConsole();
                result->Success(flutter::EncodableValue(true));
              } else {
                result->NotImplemented();
              }
          });
}
int APIENTRY wWinMain(_In_ HINSTANCE instance, _In_opt_ HINSTANCE prev,
                      _In_ wchar_t *command_line, _In_ int show_command) {


  HWND hwnd = ::FindWindow(L"FLUTTER_RUNNER_WIN32_WINDOW", L"naiyouwl");
  if (hwnd != NULL) {
    DispatchToProtocolHandler(hwnd);
    ::ShowWindow(hwnd, SW_NORMAL);
    ::SetForegroundWindow(hwnd);
    return EXIT_FAILURE;
  }
/*
 *
  else {
    AllocConsole();
    ShowWindow(GetConsoleWindow(), SW_HIDE);
  }
 * */
// https://github.com/flutter/flutter/issues/47891#issuecomment-708850435
// https://github.com/flutter/flutter/issues/47891#issuecomment-869729956
// https://github.com/dart-lang/sdk/issues/39945#issuecomment-870428151
  if (!::AttachConsole(ATTACH_PARENT_PROCESS) && ::IsDebuggerPresent()) {
    CreateAndAttachConsole();
  }   else {
    AllocConsole();
    ShowWindow(GetConsoleWindow(), SW_HIDE);
  }
  // Initialize COM, so that it is available for use in the library and/or
  // plugins.
  ::CoInitializeEx(nullptr, COINIT_APARTMENTTHREADED);

  flutter::DartProject project(L"data");

  std::vector<std::string> command_line_arguments =
      GetCommandLineArguments();

  project.set_dart_entrypoint_arguments(std::move(command_line_arguments));

  FlutterWindow window(project);
  Win32Window::Point origin(10, 10);
  Win32Window::Size size(1280, 720);
  if (!window.Create(L"naiyouwl", origin, size)) {
    return EXIT_FAILURE;
  }
  window.SetQuitOnClose(true);
  // 注册Flutter插件
  RegisterPlugins(&flutter_controller->engine());
  ::MSG msg;
  while (::GetMessage(&msg, nullptr, 0, 0)) {
    ::TranslateMessage(&msg);
    ::DispatchMessage(&msg);
  }

  ::CoUninitialize();
  return EXIT_SUCCESS;
}
